// Utils.cpp: implementation of the CUtils class
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Utils.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

////////////////////////////////////////////////////////////////////

/**
DLLV{팸/MFĈ߂̈ڍspeXgR[h
@todo xǋ̕Kv͂ȂR[hTCŶܑȂ̂œꖼOԂֈړʂexport
*/

/// GUINɈ񂾂Ă΂鏉
void CUtilsEx::Init(DWORD nFlag)
{
	CUtils::Init(nFlag);
}

/// Oobt@̃R\[
UINT CUtilsEx::IsConsole(LPCTSTR szApplicationName)
{
	return CUtils::IsConsole(szApplicationName);
}

/// R\[AvP[V̖̂𐄒肷
void CUtilsEx::SetConsoleApplicationName(LPTSTR szApplicationName, int nApplicationNameLength, LPCTSTR szWindowText, UINT nConsole)
{
	CUtils::SetConsoleApplicationName(szApplicationName, nApplicationNameLength, szWindowText, nConsole);
}

////////////////////////////////////////////////////////////////////

// DLLA^b`ɐݒ肵AȌωȂO[ö
static BYTE g_nConsole;									///< 0:ʏ 1:cmd 2:javaw
static BYTE g_nApplication;								///< vZX茋 0:YȂ
static TCHAR g_szApplicationName[CLASS_NAME_LENGTH];	///< ݂̃AvP[V

// GUINɐݒ肵AȌωȂA[LeN`ʋL̈
#ifndef XKEYMACS_IME_COMPATIBLE
extern TCHAR s_szImeName[CLASS_NAME_LENGTH];			///< IMEvZX(GUIN)
#endif
#ifdef XKEYMACS_STRICT_ARCHITECTURE
extern BYTE s_bDefaultArchitecture;						///< DLL̃A[LeN`
#endif
extern DWORD s_nProcessId;								///< GUĨvZXID
#ifndef x64
#ifdef XKEYMACS_WIN9X_OBSOLETE
extern BYTE s_bIsNT;									///< NTnȂTRUE
extern BYTE s_bIs9X;									///< 95/98ȑOȂTRUE
#endif
extern BYTE s_bIsXP;									///< XPȍ~ȂTRUE
#endif
extern BYTE s_bIsV7;									///< Vista/7ȍ~ȂTRUE

// ΏۃvZX؂ւxɓe鋤L̈
extern BYTE s_bActive;									///< LȂ TRUE
extern BYTE s_nConsole;									///< (copy) 0:ʏ 1:cmd 2:javaw
extern BYTE s_nApplication;								///< (copy) vZX茋 0:YȂ
extern TCHAR s_szApplicationName[CLASS_NAME_LENGTH];	///< (copy) ݂̃AvP[V
extern TCHAR s_szWindowName[WINDOW_TEXT_LENGTH];		///< ݂̃EBhE
extern HWND s_hWnd;										///< EBhEnh

////////////////////////////////////////////////////////////////////

/// GUINɈ񂾂Ă΂鏉
void CUtils::Init(DWORD nFlag)
{
	// o[Wp
#ifndef x64
#ifdef XKEYMACS_WIN9X_OBSOLETE
	s_bIsNT = (nFlag & 0x08) != 0;
	s_bIs9X = (nFlag & 0x04) != 0;
#endif
	s_bIsXP = (nFlag & 0x02) != 0;
#endif
	s_bIsV7 = (nFlag & 0x01) != 0;

	// vZXID̎擾
	s_nProcessId = ::GetCurrentProcessId();

#ifdef XKEYMACS_STRICT_ARCHITECTURE
	// A[LeN`̎擾
	/**
	@note Win32/x64̔@ɂāB
	eGUI IsWow64Process() 擾lL̈ɕۑĂA
	ΏۃvZXɑ΂ēlɎ擾AlrB
	Ȃ킿u3264vƂΔł͂Ȃ
	uƓA[LeN`ǂvƂΔƂȂĂB
	*/
	s_bDefaultArchitecture = (BYTE)GetProcessArchitecture(GetCurrentProcess());
#endif

#ifndef XKEYMACS_IME_COMPATIBLE
	// ݂IMÊ̎擾
	UINT n = ::ImmGetIMEFileName(::GetKeyboardLayout(0), s_szImeName, sizeof(s_szImeName) - 1);	// JEgł͂ȂoCgȂ̂Œ
	if (n == 0) _tcscpy_s(s_szImeName, _T("IME"));	// IDS_IME_FILE_NAME
#endif
}

/// vZXA^b`sxĂ΂鏉
void CUtils::Attach()
{
	// vZX؂o
	::GetModuleFileName(NULL, g_szApplicationName, countof(g_szApplicationName));
	const TCHAR* p = _tcsrchr(g_szApplicationName, _T('\\'));
	if (p) _tcscpy_s(g_szApplicationName, p + 1);

	// R\[茋ʂۑ
	g_nConsole = (BYTE)IsConsole(g_szApplicationName);

#ifdef x64
	// x64ȂvZX̖Ɏʗp̕u *64vǉ
	// R\[̃vZX̏ꍇ͕֋X32rbgƂ
	if (g_nConsole == FALSE) _tcscat_s(g_szApplicationName, _T(" *64"));
#endif
}

////////////////////////////////////////////////////////////////////

/// NTnȂTRUE
BOOL CUtils::IsNT()	// const
{
#if defined x64 || !defined XKEYMACS_WIN9X_OBSOLETE
	return TRUE;
#else
	return s_bIsNT;
#endif
}

/// 95/98ȑOȂTRUE
BOOL CUtils::Is9XorEarlier()	// const
{
#if defined x64 || !defined XKEYMACS_WIN9X_OBSOLETE
	return FALSE;
#else
	return s_bIs9X;
#endif
}

/// XPȍ~ȂTRUE
/**
@note {Iɖ{rh Windows XP ȍ~pƂȂĂB
32rbgł̓pb`Ă Windows 2000 łꉞ悤lĂB
*/
BOOL CUtils::IsXPorLater()	// const
{
#ifdef x64
	return TRUE;
#else
	return s_bIsXP;
#endif
}

/// Vista/7ȍ~ȂTRUE
BOOL CUtils::IsV7orLater()	// const
{
	return s_bIsV7;
}

////////////////////////////////////////////////////////////////////

/// ڊ񐶂ĂȂ(vZXIDGUIƓ)ꍇTRUE
BOOL CUtils::IsRestrictedProcess()
{
	return ::GetCurrentProcessId() == s_nProcessId;
}

#ifdef XKEYMACS_STRICT_ARCHITECTURE
/// w肵EBhẼA[LeN`DLL{̂ƈقȂꍇTRUE
BOOL CUtils::IsDifferentArchitecture(HWND hWnd)
{
	DWORD nProcess;
	::GetWindowThreadProcessId(hWnd, &nProcess);
	return IsDifferentArchitecture(nProcess);
}

/// w肵vZX̃A[LeN`DLL{̂ƈقȂꍇTRUE
BOOL CUtils::IsDifferentArchitecture(DWORD nProcessId)
{
	HANDLE hProcess = ::OpenProcess(PROCESS_QUERY_INFORMATION, FALSE, nProcessId);
	BOOL bArchitecture = GetProcessArchitecture(hProcess);
	::CloseHandle(hProcess);
	return s_bDefaultArchitecture != bArchitecture;
}

/// vZXnhA[LeN`擾
BOOL CUtils::GetProcessArchitecture(HANDLE hProcess)
{
	typedef BOOL (WINAPI* LPFNISWOW64PROCESS)(HANDLE, PBOOL);
	static LPFNISWOW64PROCESS pIsWow64Process;	// = NULL;
	if (pIsWow64Process == NULL) {
		static BOOL bSecond;	// = FALSE;
		if (bSecond) return FALSE;
		bSecond = TRUE;
		pIsWow64Process = (LPFNISWOW64PROCESS)::GetProcAddress(::GetModuleHandleA("kernel32"), "IsWow64Process");
		if (pIsWow64Process == NULL) return FALSE;
	}

	BOOL bResult;
	pIsWow64Process(hProcess, &bResult);
	return bResult;
}
#endif

////////////////////////////////////////////////////////////////////

/// _DLLA^b`ĂvZX擾
/**
{vO̊bB
œΏۂ̏(vZX^CgȂ)ɓ삷B

@param bImeComposition IMEI[vTRUE ȗ(ȗFALSE)
@return Ώۂ؂ւꍇTRUE

LbVɂ:
SetApplicationName̓3ނɕނłBꂼ̓ƃLbV^C~O͈ȉ̒ʂB

1. IMÊ擾ԂBIMEpɂɕύXƂ͍̂lɂ(NTȍ~ƕޕs\肷邱Ƃ)̂ŁÂ̖GUINɎ擾ĂAƎgB
@warning IME𓮓Iɕςꍇ̏͂ĖĂ(삩̃fO)
2. GetModuleFileName œꂽpX̍Ō̃t@CԂB̕񂪃vZXNɕωƂ̂(tbNΉ\Ȃ)܂茻Ił͂ȂBDLLvZXɃA^b`ꂽiKŃt@C̕܂ōς܂ĕۑĂB
3. 2̖̂IsConsoleŐ^ɂȂꍇAJgEBhẼ^CgHăvZX𐄒肷B^Cg͔Cӂ̃^C~OŕύX\邽߃LbV͂łȂ̂ŁAIsConsolěʂ̂2Ɠl̃^C~OŒוۑĂB

64rbgł̌듮ɂ:
32rbgDLLsȂL[tbNȂx64vZXɑ΂ĂsȂĂB
MSDNɂΎdl炵B64rbgDLLƓɓo^Ήł悤ɂǂ߂邪A܂܂ĂȂB
dȂ̂GetForegroundWindow()GetWindowThreadProcessId()IsWoW64()64rbgEBhEゾƔfꂽ؏~߂鏈ǉB

GetFocus / GetGetForegroundWindow / GetWindowText Ȃǂ̑ΏۃEBhEɑ΂APIs͂ōsȂAȊȌꏊł͑SĂœLbVp݌vƂB
Utils ͈ڍsB
Commands ͂ꂩύX\B
*/
BOOL CUtils::UpdateApplicationName(HWND hWnd, BOOL bImeComposition, DWORD nDebugNumber)
{
#ifdef _DEBUG
	dp(ARCHNAME ": %s %X %d %d\n", g_szApplicationName, hWnd, bImeComposition, nDebugNumber);
#endif

	s_bActive = TRUE;

	// ^CgNA
	s_szWindowName[0] = _T('\0');

	// IME
	if (bImeComposition) {
#ifdef XKEYMACS_IME_COMPATIBLE
		// ݂IMÊ擾
		TCHAR buf[CLASS_NAME_LENGTH];
		UINT n = ::ImmGetIMEFileName(::GetKeyboardLayout(0), buf, sizeof(buf) - 1);	// JEgł͂ȂoCgȂ̂Œ
		if (n == 0) _tcscpy_s(buf, _T("IME"));	// IDS_IME_FILE_NAME

		if (_tcscmp(s_szApplicationName, buf) == 0) goto unchanged;
		_tcscpy_s(s_szApplicationName, buf);
#else
		if (_tcscmp(s_szApplicationName, s_szImeName) == 0) goto unchanged;
		_tcscpy_s(s_szApplicationName, s_szImeName);
#endif

		// LbVXV
		s_nConsole = 0;
		s_nApplication = 0;
		goto changed;
	}

	// ^Cg擾
	::GetWindowText(hWnd, s_szWindowName, countof(s_szWindowName));

	// LbVXV
	s_nConsole = g_nConsole;
	s_nApplication = g_nApplication;

	// R\[
	if (g_nConsole) {
		TCHAR buf[WINDOW_TEXT_LENGTH];
		SetConsoleApplicationName(buf, countof(buf), s_szWindowName, g_nConsole);
		if (_tcscmp(s_szApplicationName, buf) == 0) goto unchanged;

		_tcscpy_s(s_szApplicationName, buf);
		goto changed;
	}

	// ʏAv
	if (_tcscmp(s_szApplicationName, g_szApplicationName) == 0) {
	unchanged:
		if (s_hWnd == hWnd) return FALSE;
		goto changed;
	}

	_tcscpy_s(s_szApplicationName, g_szApplicationName);
changed:
	s_hWnd = hWnd;
	dp(ARCHNAME ": %s %X SYNC\n", s_szApplicationName, s_hWnd);
	return TRUE;
}

/// R\[AvP[V̖̂𐄒肷
/**
R\[̏ꍇpBCUtils::IsConsole(szProcessName) ^̏ꍇ̂݌ĂяoƁB
܂ szProcessName ̓e "javaw.exe" ǂ𒲂ׁA
conhostn(cmd.exe)̏ꍇ̖O␳Javan(javaw.exe)̏ꍇ2ނ̕␳ɕ򂷂B
ꂼ̕␳p^[KpAEBhE^CgYvZX𐄒肷B

@param [out] szApplicationName
@param [in] nApplicationNameLength
@param [in] szWindowText
@param [in] szProcessName
*/
void CUtils::SetConsoleApplicationName(LPTSTR szApplicationName, int nApplicationNameLength, LPCTSTR szWindowText, UINT nConsole)
{
	ASSERT(szApplicationName);
	ASSERT(szWindowText);
	ASSERT(nConsole > 0);

	// Javan̖O␳
	/**
	ɏB @todo XNvg@\폜
	*/
	if (nConsole == 2) {
		size_t n = _tcslen(s_szWindowName);
		if (n >= 19 && _tcsicmp(szWindowText + n - 19, _T(" - Eclipse Platform")) == 0) {
			_tcscpy_s(szApplicationName, nApplicationNameLength, _T("eclipse.exe"));
		} else if (!_tcsicmp(szWindowText, _T("BlueJ"))
			    || !_tcsnicmp(szWindowText, _T("BlueJ: "), 7)) {
			_tcscpy_s(szApplicationName, nApplicationNameLength, _T("bluej.exe"));
		} else if (!_tcsicmp(szWindowText, _T("JUDE"))
			    || !_tcsnicmp(szWindowText, _T("JUDE - "), 7)) {
			_tcscpy_s(szApplicationName, nApplicationNameLength, _T("jude.exe"));
		} else {
			// ŶȂ΃vZX̂܂܎g
			_tcscpy_s(szApplicationName, nApplicationNameLength, _T("javaw.exe"));
		}
		return;
	}

	// conhostn̖O␳
	/**
	1: " - " Ō猟B4
	2: "Command" "R}h" ̕񂪂 cmd.exe ɂ
	@todo ̓̕WXgXNvgŕύX\ɂׂ
	3: 擪̒^(IƂǗ҂Ȃǂ̕)菜
	4: ^CgR}hC+Ƃ݂ȂAR}ho
	5: ꂽR}hɊgqȂΒǉ

	(dv)łׂ͂ȃAvƃEBhE̕ύX@\A
	{ł͂Ȃׂ̃AvɓAȏ̕␳ʂ𓾂悤HvB
	܂AEBhE̕ύXDLL̃tbNƑS֌WȂ悤Ɍ󂯂邽߁A
	{o[WY@\͑S폜B

	@todo .exe Ƃ̊gq͍폜Ă珈ق񂶂Ȃ낤Bٍc[ł͍폜Ă画肵Ă邪܂Ŗ͋NĂȂBĐ݌v̋@΍폜B

	:
	uVisual Studio .NET 2003 R}h vvgv  ucmd.exev\n
	uVisual Studio R}h vvg (2010)v  ucmd.exev\n
	uI Ǘ: C:\Windows\SysWOW64\cmd.exe - "a b c" "foo.txt"v  ua b c.exev\n
	uC:\cygwin\bin\bash.exev  ubash.exev\n
	*/

	// 1. " - " Ō番
	LPCTSTR p = NULL;
	for (LPCTSTR pp = szWindowText;;) {
		pp = _tcsstr(pp, _T(" - "));
		if (pp == NULL) break;
		p = pp + 3;
		pp += 2;
	}
	if (p) goto extract;

	// 2. cmd.exe Azłꍇ͌肵ďI
	static LPCTSTR szCommand[] = {
		_T("R}h"),
		_T("command"),				// At@xbgLower CaseĔr̂Œ
	};

	TCHAR buf[0x100];
	_tcscpy_s(buf, szWindowText);
	_tcslwr_s(buf);
	size_t i;
	for (i = 0; i < countof(szCommand); i++) {
		LPCTSTR r = _tcsstr(buf, szCommand[i]);
		if (r) {
			_tcscpy_s(szApplicationName, nApplicationNameLength, _T("cmd.exe"));
			return;
		}
	}

	// 3. 擪̒^菜
	static LPCTSTR szRemove[] = {
		_T("͈͎w "),			// Windows XP/Windows 7 Menu
		_T("XN[ "),			// Windows XP/Windows 7 Menu
		_T("I "),				// Windows XP/Windows 7 
		_T("Ǘ: "),				// uǗҁv͍Ōɔ

		_T("Mark "),
		_T("Scroll "),
		_T("Select "),
		_T("Administrator: "),
	};

	p = szWindowText;
	for (i = 0; i < countof(szRemove); i++) {
		size_t n = _tcslen(szRemove[i]);
		if (_tcsnicmp(p, szRemove[i], n) == 0) p += n;
	}

	// 4. ^CgR}hC+Ƃ݂ȂAR}ho
extract:
	_tcscpy_s(szApplicationName, nApplicationNameLength, p);

	// R}h̕
	TCHAR* ps;
	if (szApplicationName[0] == _T('"') && (ps = _tcschr(szApplicationName + 1, _T('"'))) != NULL) {
		// _uNH[g̒go
		*ps = _T('\0');
		_tcscpy_s(szApplicationName, nApplicationNameLength, szApplicationName + 1);
	} else if ((ps = _tcschr(szApplicationName, _T(' '))) != NULL) {
		// ȍ~͍폜
		*ps = _T('\0');
	}

	// pX
	ps = _tcsrchr(szApplicationName, _T('\\'));
	if (ps) _tcscpy_s(szApplicationName, nApplicationNameLength, ps + 1);

	// 5. ꂽR}hɊgqȂΒǉ
	size_t n = _tcslen(szApplicationName);
	if (n < 4 || _tcsicmp(szApplicationName + n - 4, _T(".exe")) != 0) {
		_tcscat_s(szApplicationName, nApplicationNameLength, _T(".exe"));
	}
}

/// _DLLA^b`ĂvZX擾
LPCTSTR CUtils::GetApplicationName()	// const
{
	return s_szApplicationName;
}

/// Ώۂ̃EBhEnh擾
HWND CUtils::GetWindow()	// const
{
	return s_hWnd;
}

////////////////////////////////////////////////////////////////////

/*
/// ݂̃W[̓삪LȂ TRUE (̃A[LeN`LɂȂ FALSE ɂȂ)
void CUtils::SetActive(BYTE bActive)
{
	s_bActive = bActive;
}

/// ݂̃W[̓삪LȂ TRUE (̃A[LeN`LɂȂ FALSE ɂȂ)
BOOL CUtils::GetActive()	// const
{
	return s_bActive;
}
*/

////////////////////////////////////////////////////////////////////

/// ʐMT
/**
ʐMvgRɂ

N:
1. vONEBhE𐶐 FindWindow őTA
 WM_USER_FOUND 𑗂B
2. WM_USER_FOUND M FindWindow ő{

M:
nhĂ΋LɃf[^ WM_USER_SEND 𑗂B

M:
Lf[^ǂݍށB
*/
/*
void CUtils::SeekPair(UINT Msg)
{
#ifdef x64
	g_hWndTarget = ::FindWindow(_T("XKeymacs"), NULL);
#else
	g_hWndTarget = ::FindWindow(_T("XKeymacs64"), NULL);
#endif
	if (g_hWndTarget) ::PostMessage(g_hWndTarget, Msg, 0, 0);
}
*/

////////////////////////////////////////////////////////////////////

// _CAO֘A

/// ݂̃EBhEnh_CAOǂ𔻒f
BOOL CUtils::IsDialog()
{
	return ::GetParent(s_hWnd) != NULL;
}

/// p_CAÕ^Cg
static LPCTSTR g_rszFindTable[] = {
	_T(""),					// notepad, wordpad, IE, regedit,
								// Excel, Front Page, PowerPoint, Acrobat Reader, IBM HPB
	_T("Find"),					// notepad, Outlook, Outlook Express, Opera
	_T("Find in this Page"),	// Mozilla
	_T("Find/Replace"),			// Eclipse
	_T("{"),			// Becky!
	_T("["),			// Becky!
	_T("̌"),			// M$ VC++
	_T("ƒu"),			// M$ Word, 123
	_T("̃eLXǧ"),	// Lotus Notes
	_T("̃y[W"),		// Netscape 6
	_T("񌟍"),			// Dana
	_T("/u"),			// PHP Editor
	_T("u"),
	_T("Replace"),
};

/// ݂̃EBhẼ^Cg猟p_CAOǂ𔻒f
BOOL CUtils::IsFindDialog()
{
	for (int i = 0; i < countof(g_rszFindTable); i++) {
		if (_tcsicmp(s_szWindowName, g_rszFindTable[i]) == 0) return TRUE;
	}
	return FALSE;
}

////////////////////////////////////////////////////////////////////

// Nbv{[h֘A	/// @warning Nbv{[h֘AUNICODErh̐s\Ȃߒ

/**
@todo Nbv{[hǂݏASakuraEditor ƂvZX̂ݓꈵĂ邪A̓vZXɃtOĔ肵قȂB
*/

BOOL CUtils::OpenClipboard()
{
	const int RETRY_COUNT = 0x10;

	BOOL bOpened = FALSE;
	for (int i = 0; i <= RETRY_COUNT; ++i) {
		if (::OpenClipboard(NULL)) {
//			Log(_T("ok (%d)"), i);
			bOpened = TRUE;
			break;
		} else {
			Sleep(1);	// for OpenOffice
//			Log(_T("CUtils::OpenClipboard: %d (%d)"), GetLastError(), i);
		}
	}
	ASSERT(bOpened);
	return bOpened;
}

/// Nbv{[h̕(ChŊZ)Ԃ
int CUtils::GetClipboardTextLength()
{
	CString strClipboardText;
	GetClipboardText(strClipboardText);
#ifdef MFCDLL
	SetClipboardText(strClipboardText);
#else
	SetClipboardText(strClipboardText.c_str());
#endif

#ifdef _UNICODE
	return strClipboardText.GetLength();
#else
#ifdef MFCDLL
	return ::MultiByteToWideChar(CP_ACP, 0, strClipboardText, -1, NULL, 0);
#else
	return ::MultiByteToWideChar(CP_ACP, 0, strClipboardText.c_str(), -1, NULL, 0);
#endif
#endif
}

BOOL CUtils::GetClipboardText(CString& strClipboardText)
{
#ifdef MFCDLL
	if (!strClipboardText) {
		return FALSE;
	}
#endif

	strClipboardText.Empty();

	if (!OpenClipboard()) {
//		CUtils::Log(_T("Cannot open the Clipboard"));
		return FALSE;
	}

/*
	{
		Log(_T("GetClipboardText"));
		UINT uFormat = 0;
		for (;;) {
			uFormat = EnumClipboardFormats(uFormat);
			if (uFormat) {
				Log(_T("uFormat = %d"), uFormat);
			} else {
				break;
			}
		}
// winuser.h
//#define CF_TEXT             1
//#define CF_METAFILEPICT     3
//#define CF_OEMTEXT          7
//#define CF_UNICODETEXT      13
//#define CF_ENHMETAFILE      14
//#define CF_LOCALE           16
//#define CF_DSPTEXT          0x0081
// OwnerLink						49155
// Native							49156
// DataObject						49161
// Embed Source						49163
// Object Descriptor				49166
// Ole Private Data					49171
// Rich Text Format					49311
// Rich Text Format					49312
// HTML Format						49360
// HTML Format						49361
// Link								49408
// RTF As Text						49595
// Rich Text Format Without Objects	49618
// Star Object Descriptor (XML)		49681
// Star Embed Source (XML)			49708
// HPB HTML Format					49742
	}
*/

	UINT uFormat = CF_OEMTEXT;
	if (IsSakuraEditor()) {
		uFormat = CF_TEXT;
	}

	HANDLE hClipboardText;
	if ((hClipboardText = ::GetClipboardData(uFormat)) == NULL) {
//		DWORD dw = GetLastError();
//		CUtils::Log(_T("Unable to get Clipboard data: %d"), dw);
		CloseClipboard();
		return FALSE;
	}

	strClipboardText.Format(_T("%s"), hClipboardText);
	EmptyClipboard();
	CloseClipboard();
	return TRUE;
}

BOOL CUtils::SetClipboardText(LPCTSTR szClipboardText)
{
	if (!OpenClipboard()) {
//		CUtils::Log(_T("Cannot open the Clipboard in SetClipboardText"));
		return FALSE;
	}

	size_t nBytes = (_tcslen(szClipboardText) + 1) * sizeof(TCHAR);	// szClipboardText.GetLength() + 1;
	HGLOBAL hClipboardText = GlobalAlloc(GHND, nBytes);
	if (hClipboardText == NULL) {
//		CUtils::Log(_T("Failed: GlobalAlloc in SetClipboardText"));
		CloseClipboard();
		return FALSE;
	}

	LPTSTR lpStr = (LPTSTR)GlobalLock(hClipboardText);
	memcpy(lpStr, szClipboardText, nBytes);	// lstrcpyn(lpStr, szClipboardText, nLength);
	GlobalUnlock(hClipboardText);
	EmptyClipboard();

	UINT uFormat = CF_OEMTEXT;
	if (IsSakuraEditor()) {
		uFormat = CF_TEXT;
	}

	if ((hClipboardText = ::SetClipboardData(uFormat, hClipboardText)) == NULL) {
//		DWORD dw = GetLastError();
//		CUtils::Log(_T("Unable to set Clipboard data: %d"), dw);
		CloseClipboard();
		return FALSE;
	}

	CloseClipboard();
	return TRUE;
}

// If Clipboard data is empty, return ture.
// You must CopyNextCharacter in previous step. (IsEOF)
// You must CopyBackCharacter in previous step. (IsTOF)
// Clipboard data is destroyed.
BOOL CUtils::IsTOForEOF()
{
	CString strClipboardText;
	GetClipboardText(strClipboardText);
	return strClipboardText.IsEmpty()			// for normal application
		|| strClipboardText.GetLength() >= 3;	// for VC++
}

////////////////////////////////////////////////////////////////////

/// Oobt@̃R\[
/**
^Cgɂ␳KvȃvZXȂΐ^ԂB
̒l̓^Cgɂ␳łp\Ȃ̂ŃLbV̂悤ɕۑĂƂ\B

{c[ɂAvP[V̒`3ނB
1. ʏAvP[VBvZX݂̂Ĕ肷B
2. R\[nB^CgăvZX𐄒肵Ȃ瓮삷Bvcmd.exêƁB32/64rbg̋ʂ͂Ȃ(łȂ)B
3. R\[n2B^Cgɂ鐄͕svAXKeymacs̃R}h(quityank)̓R\[ɕϊĈKv̂́BcygwinȂǂ̃R\[ʂgAvR\[œ삷VFށBق32rbgAv݂ȂA32/64rbg̋ʂ͏ق悢B
4. JavaWnB^CgăvZX𐄒肵Ȃ瓮삷BƌlIɂ͍؂̂ĂO[vEclipseŶŌ̗܂𗬂ȂT|[g𑱂˂΂ȂȂB

R\[̃vZXXPȑOVistaȍ~ł͔ɈقȂB
XPȑO: GUIłcmd.exebash.exeƂĔFADLLłxkeymacs.exeƂĔFB
Vistaȍ~: GUIłcmd.exebash.exeƂĔFADLLłconhost.exeƂĔF(7̏ꍇ)B
ɓ͈قȂ邪AvGUIo^DLLsƂňقȂ閼OƂĔFĂ͗lB

łbashȂǂ͌Œ薼ƔrăR\[sȂĂA񂩂炱̌Œ薼Sɔp~AGUIo^̂ cmd.exe 32rbgvZXƂēʈ鏈ƂB
DLĹAΏۃvZX conhost  xkeymacs R\[tOLB
*/
UINT CUtils::IsConsole(LPCTSTR szApplicationName)
{
	if  (_tcsicmp(szApplicationName, _T("javaw.exe")) == 0) return 2;
	return
		_tcsicmp(szApplicationName, _T("conhost.exe")) == 0 ||	///< Windows 7
		_tcsicmp(szApplicationName, _T("conime.exe")) == 0 ||	///< Windows Vista
#ifdef XKEYMACS_WIN9X_OBSOLETE
		_tcsicmp(szApplicationName, _T("winoa386.mod")) == 0 ||	///< Windows 95/98
#endif
		_tcsicmp(szApplicationName, _T("xkeymacs.exe")) == 0;	///< Windows XP
}

/// R\[
BOOL CUtils::IsConsole()
{
	return s_nConsole == 1;		// return IsConsole(g_szApplicationName);
}

/// Java
BOOL CUtils::IsJavaW()
{
	return s_nConsole == 2;		// return IsJavaW(g_szApplicationName);
}

////////////////////////////////////////////////////////////////////

// vZX

/// @todo ̃n[hR[fBO̗Aǂ񂩂Ƃcce[uƑSrErɂănbVe[uWXgXNvgGWoRœnȂǁB

/// @note IsXxxn͊{IɑS constB{Iɂ̊֐̌ʂ DLL vZXɃA^b`Ăꐶω邱Ƃ͂Ȃ̂ŃLbV\Bpx͎̑̂Oɔ肵ĂׂB

////////////////////////////////////////////////////////////////////

#ifdef XKEYMACS_DEFAULT_IGNORE

/// ftHgvZX̔
/**
SKKIME̐ݒsn点̂ړÎ߁AftHg͔p~B
XKEYMACS_DEFAULT_IGNORE `ΗLɂȂB
vZX͕KvɉĂɒǉ/폜邱ƁB
*/
BOOL CUtils::IsDefaultIgnoreApplication()
{
#define Is(File) _tcsicmp(s_szApplicationName, _T(File)) == 0
	if (
//		Is("sh.exe") ||
		Is("bash.exe") ||
//		Is("csh.exe") ||
//		Is("tcsh.exe") ||
//		Is("pdksh.exe") ||
//		Is("zsh.exe") ||

//		Is("Mule.exe") ||
//		Is("MuleNT.exe") ||
//		Is("MuleCD.exe") ||
		Is("Meadow.exe") ||
//		Is("Meadow95.exe") ||
		Is("MeadowNT.exe") ||
		Is("Emacs.exe") ||

		Is("astecx.exe") ||
		Is("XWin.exe") ||
//		_tcsnicmp(s_szApplicationName, _T("lispworks-personal-"), 19) == 0 ||
		0) return TRUE;

	if (
		Is("ttermpro.exe") ||
		Is("vs.exe") ||
		Is("xyzzy.exe") ||
		0) {
		if (!IsDialog()) return TRUE;
	}
#undef Is

	return FALSE;
}

#endif

////////////////////////////////////////////////////////////////////

/**
vZX

ȉ͖
̂߁AvZX2ɕďB
1ڂDLLvZXɊ񐶂uԂŁAvZXƕ̔rsȂĐlɕϊB
2ڂ͏]Ɠ^C~OŁAp֐̓1ڂ̐lƂ̔rsȂB

W͌lIȗD揇(W͏s)
@todo XNvgŎwł悤ɂāAgĂȂȂ͔̂r
*/

#define Def(Name, File)\
BOOL CUtils::Is##Name() { return _tcsicmp(s_szApplicationName, _T(File)) == 0; }
#define Def2(Name, File1, File2)\
BOOL CUtils::Is##Name() { return _tcsicmp(s_szApplicationName, _T(File1)) == 0 || _tcsicmp(s_szApplicationName, _T(File2)) == 0; }

// Windows W
Def(Explorer, "explorer.exe");
Def(Notepad, "notepad.exe");
Def(Wordpad, "wordpad.exe");
Def(InternetExplorer, "iexplore.exe");
Def(OutlookExpress, "msimn.exe");
Def(Paint, "mspaint.exe");

// GfB^
Def(Hidemaru, "hidemaru.exe");					// 2011.04.20s
Def(Oedit, "oedit.exe");						// 2011.02.28
Def(TeraPad, "TeraPad.exe");					// 2011.02.17
Def(SakuraEditor, "sakura.exe");				// 2010.10.17
Def(K2Editor, "K2Editor.exe");					// 2010.10.10
Def(Dana, "Dana.exe");							// 2008.02.20s
Def2(JmEditor, "JmEdit.exe", "JmEdit2.exe");	// 2004.10.03
Def(EdLeaf, "edleaf.exe");						// 2003.02.26

// J
Def(VisualStudioDotNet, "devenv.exe");
Def(VisualCpp, "msdev.exe");
Def(VisualBasic, "VB6.EXE");
Def(MSDN, "hh.exe");
Def(BorlandCppBuilder, "bcb.exe");
Def(CodeWarrior, "IDE.exe");
Def(Eclipse, "eclipse.exe");	// SetConsoleApplicationName ŕ␳

// uEU
Def2(Firefox, "firefox.exe", "mozilla.exe");
Def(Opera, "opera.exe");
Def(Sleipnir, "Sleipnir.exe");
Def(Lunascape, "Luna.exe");

// [
Def(Thunderbird, "thunderbird.exe");
Def(Becky, "b2.exe");
Def(Eudora, "Eudora.exe");
Def(TuruKameMail, "TuruKame.exe");
Def(Shuriken, "JsvMail.exe");

// ItBXn
Def(MicrosoftWord, "winword.exe");
Def(Excel, "Excel.exe");
Def(MicrosoftPowerPoint, "PowerPnt.exe");
Def(Outlook, "outlook.exe");
Def(Project, "WINPROJ.EXE");
Def(Access, "MSACCESS.EXE");
Def(MicrosoftFrontPage, "frontpg.exe");

Def2(OpenOffice, "soffice.exe", "soffice.bin");

Def(Lotus123, "123w.exe");
Def(LotusNotes, "nlnotes.exe");
Def(LotusWordPro, "wordpro.exe");

// AEgCvZbT
Def(Autla, "Autla.exe");
Def(eMemoPad, "eMemoPad.exe");
Def(StoryEditor, "STRYEDIT.EXE");
Def(Nami2000, "Nami2000.exe");

// 摜Ȃ
Def(CorelDRAW, "CorelDrw.exe");
Def(Flash, "Flash.exe");
Def(Dreamweaver, "Dreamweaver.exe");
Def(AdobeReader, "AcroRd32.exe");
Def(Photoshop, "Photoshp.exe");
Def(Illustrator, "Illustrator.exe");
Def(Director, "Director.exe");
Def2(Fireworks, "Fireworks 4.exe", "Fireworks.exe");

// ̑
Def(DWFM, "dwfm.exe");
Def(EggExplorer, "EggExp.exe");
Def(Husen, "husen.exe");
Def(ezHTML, "ezhtml.exe");
Def(PHPEditor, "php_editor.exe");
Def(IPMessenger, "ipmsg.exe");
Def2(Reget, "Regetdx.exe", "Regetjr.exe");
Def(OpenJane, "Jane2ch.exe");

#undef Def
#undef Def2

BOOL CUtils::IsVisualBasicEditor()
{
	if (IsVisualBasic()) {
		return TRUE;
	}

	if (IsAccess()
	 || IsExcel()
	 || IsMicrosoftFrontPage()
	 || IsMicrosoftPowerPoint()
	 || IsMicrosoftWord()
	 || IsOutlook()
	 || IsProject()) {
		if (!_tcsnicmp(s_szWindowName, _T("Microsoft Visual Basic - "), 25)) return TRUE;
	}
	return FALSE;
}

BOOL CUtils::IsAtok()
{
	return !_tcsnicmp(s_szApplicationName, _T("ATOK"), 4) && !_tcsnicmp(s_szApplicationName + _tcslen(s_szApplicationName) - 4, _T(".IME"), 4);
}

////////////////////////////////////////////////////////////////////

// ̑̃wpE[eBeB	/// @todo Shared̈̏Ɗ֘A̒Ⴂ͕̂ʃNXɕ

/// vZX
BOOL CUtilsEx::Run(LPCTSTR szCommandLine, BOOL isWait)
{
	// AnWnňقȂ邪obt@Ƀf[^܂\̂ňႢz
	TCHAR buf[MAX_PATH + 1];
	_tcscpy_s(buf, countof(buf) - 1, szCommandLine);

	STARTUPINFO si;
	ZeroMemory(&si, sizeof(si));
	si.cb = sizeof(si);

	PROCESS_INFORMATION pi;
//	ZeroMemory(&pi, sizeof(pi));

	BOOL rc = ::CreateProcess(NULL, buf, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
	if (rc) {
		if (isWait) {
			::WaitForSingleObject(pi.hProcess, INFINITE);
		}

		::CloseHandle(pi.hThread);
		::CloseHandle(pi.hProcess);
	}

	return rc;
}

/// L[{[hԂ̍XV
/**
bVkԖڂ̉zL[̏ԂbStateɕύX

@return TRUE (zL[̓ǂݏɎsꍇ͏𒆒fFALSEԂ)
*/
BOOL CUtilsEx::UpdateKeyboardState(BYTE bVk, BYTE bState)
{
	BYTE ks[256];	// = {'\0'};
	BOOL rc;	// = FALSE;

	if ((rc = ::GetKeyboardState(ks)) != FALSE) {
		ks[bVk] = bState;
		rc = ::SetKeyboardState(ks);
	}
	return rc;
}

////////////////////////////////////////////////////////////////////

/*
/// 񒆂 '*' ̈ʒuŌ肳u炩̎ނ̒lvԂ
int CUtilsEx::GetWindowTextType(LPCTSTR szWindowText)
{
	CString strWindowText = szWindowText;

	int nWindowTextType = IDS_WINDOW_TEXT_IGNORE;

	if (3 <= strWindowText.GetLength()
	 && strWindowText.Find(_T('*')) == 0
	 && strWindowText.ReverseFind(_T('*')) == strWindowText.GetLength() - 1) {
		// *LR* Ȃ
		nWindowTextType = IDS_WINDOW_TEXT_MATCH;
	} else if (2 <= strWindowText.GetLength()
			&& strWindowText.Find(_T('*')) != 0
			&& strWindowText.ReverseFind(_T('*')) == strWindowText.GetLength() - 1) {
		// LR* L*R* Ȃ
		nWindowTextType = IDS_WINDOW_TEXT_MATCH_FORWARD;
	} else if (2 <= strWindowText.GetLength()
			&& strWindowText.Find(_T('*')) == 0
			&& strWindowText.ReverseFind(_T('*')) != strWindowText.GetLength() - 1) {
		// *LR *L*R Ȃ
		nWindowTextType = IDS_WINDOW_TEXT_MATCH_BACKWARD;
	} else if (!strWindowText.IsEmpty()
			&& strWindowText.Find(_T('*')) != 0
			&& strWindowText.ReverseFind(_T('*')) != strWindowText.GetLength() - 1) {
		// L*R L**R Ȃ
		nWindowTextType = IDS_WINDOW_TEXT_MATCH_FULL;
	}

	return nWindowTextType;
}
*/

/*
// for debug
void CUtils::Log(LPTSTR fmt, ...)
{
	va_list ap;
	va_start(ap, fmt);

	static const int LOG_MAX = 0x10000;
	TCHAR szLog[LOG_MAX] = {'\0'};

	for (unsigned int nIndex = 0; nIndex < _tcslen(fmt); ) {
		LPTSTR pNextString = fmt + nIndex;
		LPTSTR pLogEnd = szLog + _tcslen(szLog);

		if (*pNextString == _T('%')) {
			TCHAR szFormatTag[LOG_MAX] = {'0'};
			_tcscpy(szFormatTag, pNextString);

			switch (GetFormatTag(szFormatTag)) {
			case _T('d'):
			case _T('i'):
			case _T('o'):
			case _T('x'):
			case _T('X'):
			case _T('u'):
			case _T('c'):
				_stprintf(pLogEnd, szFormatTag, va_arg(ap, int));
				break;
			case _T('s'):
				_stprintf(pLogEnd, szFormatTag, va_arg(ap, LPTSTR));
				break;
			case _T('f'):
			case _T('e'):
			case _T('E'):
			case _T('g'):
			case _T('G'):
				_stprintf(pLogEnd, szFormatTag, va_arg(ap, double));
				break;
			case _T('p'):
				_stprintf(pLogEnd, szFormatTag, va_arg(ap, void *));
				break;
			case _T('n'):
				_stprintf(pLogEnd, szFormatTag, va_arg(ap, int *));
				break;
			case _T('%'):
			default:
				_stprintf(pLogEnd, _T("%s"), szFormatTag);
				break;
			}

			nIndex += _tcslen(szFormatTag);
		} else {
			TCHAR szString[LOG_MAX] = {'0'};
			_tcscpy(szString, pNextString);
			LPTSTR pString = _tcstok(szString, _T("%"));
			_stprintf(pLogEnd, _T("%s"), pString);

			nIndex += _tcslen(pString);
		}
	}

	va_end(ap);

	static int n = 0;
	TCHAR szPath[MAX_PATH] = {'\0'};
	if (SHGetSpecialFolderPath(NULL, szPath, CSIDL_APPDATA, TRUE)) {
		_tmakepath(szPath, NULL, szPath, _T("xkeylog"), _T("txt"));
	} else {
		_tcscpy(szPath, _T("c:\\xkeylog.txt"));
	}
	FILE *fp = _tfopen(szPath, _T("a"));
	_ftprintf(fp, _T("%8d: %s	%s\n"), n++, s_szApplicationName, szLog);
	fflush(fp);
	fclose(fp);
}

void CUtils::PrintWindowInfo(WINDOWINFO* pwi)
{
	Log(_T("windowinfo.cbSize: %d"), pwi->cbSize);
	Log(_T("windowinfo.rcWindow.top: %d"), pwi->rcWindow.top);
	Log(_T("windowinfo.rcWindow.bottom: %d"), pwi->rcWindow.bottom);
	Log(_T("windowinfo.rcWindow.left: %d"), pwi->rcWindow.left);
	Log(_T("windowinfo.rcWindow.right: %d"), pwi->rcWindow.right);
	Log(_T("windowinfo.rcClient.top: %d"), pwi->rcClient.top);
	Log(_T("windowinfo.rcClient.bottom: %d"), pwi->rcClient.bottom);
	Log(_T("windowinfo.rcClient.left: %d"), pwi->rcClient.left);
	Log(_T("windowinfo.rcClient.right: %d"), pwi->rcClient.right);
	Log(_T("windowinfo.dwStyle: %d"), pwi->dwStyle);
	Log(_T("windowinfo.dwExStyle: %d"), pwi->dwExStyle);
	Log(_T("windowinfo.dwWindowStatus: %d"), pwi->dwWindowStatus);
	Log(_T("windowinfo.cxWindowBorders: %d"), pwi->cxWindowBorders);
	Log(_T("windowinfo.cyWindowBorders: %d"), pwi->cyWindowBorders);
	Log(_T("windowinfo.atomWindowType: %d"), pwi->atomWindowType);
	Log(_T("windowinfo.wCreatorVersion: %d"), pwi->wCreatorVersion);
}

int CUtils::GetFormatTag(LPTSTR szFormatTag)	// LPTSTRcƁcIH
{
	if (*(szFormatTag) != _T('%')) {
		return NULL;
	}

	unsigned int nIndex = 1;

	// flags
	while (nIndex < _tcslen(szFormatTag)) {
		switch (*(szFormatTag + nIndex)) {
		case _T('-'):
		case _T('+'):
		case _T(' '):
		case _T('0'):
		case _T('#'):
			++nIndex;
			continue;
		default:
			break;
		}

		break;
	}

	// width
	while (_istdigit(*(szFormatTag + nIndex))) {
		++nIndex;
	}

	// precision
	if (*(szFormatTag + nIndex) == _T('.')) {
		++nIndex;
		while (_istdigit(*(szFormatTag + nIndex))) {
			++nIndex;
		}
	}

	// prefix
	switch (*(szFormatTag + nIndex)) {
	case _T('h'):
	case _T('l'):
	case _T('L'):
		++nIndex;
		break;
	}

	// type
	switch (*(szFormatTag + nIndex)) {
	case _T('d'):
	case _T('i'):
	case _T('o'):
	case _T('x'):
	case _T('X'):
	case _T('u'):
	case _T('c'):
	case _T('s'):
	case _T('f'):
	case _T('e'):
	case _T('E'):
	case _T('g'):
	case _T('G'):
	case _T('p'):
	case _T('n'):
	case _T('%'):
		*(szFormatTag + nIndex + 1) = NULL;
		return *(szFormatTag + nIndex);
	default:
		*(szFormatTag + nIndex) = NULL;
		return NULL;
	}
}
*/
