// FunctionDefinition.h: interface for the CFunctionDefinition class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FUNCTIONDEFINITION_H__22E7286C_E86F_4964_896F_28A66E94A7A2__INCLUDED_)
#define AFX_FUNCTIONDEFINITION_H__22E7286C_E86F_4964_896F_28A66E94A7A2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "xkeymacsdll.h"

class AFX_EXT_CLASS CFunctionDefinition
{
public:
	void RemoveKey(int nApplicationID, int nCommandType, int nKey);
	void GetKey(int nApplicationID, int nKeyID, int *pCommandType, int *pKey);
	int GetKeyNumber(int nApplicationID);
	void SetKey(int nApplicationID, int nCommandType, int nKey);
	void ClearKey(int nApplicationID);
#ifdef MFCDLL
	CString GetDefinition();
	CString GetSymbol();
	void SetDefinition(CString szDefinition);
	void SetSymbol(CString szSymbol);
	CFunctionDefinition(CString szSymbol, CString szDefinition);
#else
	string GetDefinition();
	string GetSymbol();
	void SetDefinition(string szDefinition);
	void SetSymbol(string szSymbol);
	CFunctionDefinition(string szSymbol, string szDefinition);
#endif

private:
#ifdef MFCDLL
	CObList m_oKey[MAX_APP];
	CString m_szDefinition;
	CString m_szSymbol;
#else
	vector<KeyBind> m_oKey[MAX_APP];	// |C^ł͂Ȃ
	string m_szDefinition;
	string m_szSymbol;
#endif
};

#endif // !defined(AFX_FUNCTIONDEFINITION_H__22E7286C_E86F_4964_896F_28A66E94A7A2__INCLUDED_)
